# Copyright (C) 1991-2003 Altera Corporation
# Any  megafunction  design,  and related netlist (encrypted  or  decrypted),
# support information,  device programming or simulation file,  and any other
# associated  documentation or information  provided by  Altera  or a partner
# under  Altera's   Megafunction   Partnership   Program  may  be  used  only
# to program  PLD  devices (but not masked  PLD  devices) from  Altera.   Any
# other  use  of such  megafunction  design,  netlist,  support  information,
# device programming or simulation file,  or any other  related documentation
# or information  is prohibited  for  any  other purpose,  including, but not
# limited to  modification,  reverse engineering,  de-compiling, or use  with
# any other  silicon devices,  unless such use is  explicitly  licensed under
# a separate agreement with  Altera  or a megafunction partner.  Title to the
# intellectual property,  including patents,  copyrights,  trademarks,  trade
# secrets,  or maskworks,  embodied in any such megafunction design, netlist,
# support  information,  device programming or simulation file,  or any other
# related documentation or information provided by  Altera  or a megafunction
# partner, remains with Altera, the megafunction partner, or their respective
# licensors. No other licenses, including any licenses needed under any third
# party's intellectual property, are provided herein.

# Quartus II: Generate Tcl File for Project
# File: blink.tcl
# Generated on: Fri Feb 21 12:09:15 2003

# Close currently opened project if any
project close;

# Create and open the project
if {![project exists blink]} {
	project create blink;
}
project open blink;

# Software Build Assignments for release
if {![project swb_exists release]} {
	project create_swb release;
}
project set_active_swb release;

swb add_assignment "" "" "" "ARM_CPP_COMMAND_LINE" "-O2";
swb add_assignment "" "" "" "BYTE_ORDER" "LITTLE ENDIAN";
swb add_assignment "" "" "" "DO_POST_BUILD_COMMAND_LINE" "OFF";
swb add_assignment "" "" "" "GNUPRO_ARM_CPP_COMMAND_LINE" "-O3 -fomit-frame-pointer";
swb add_assignment "" "" "" "GNUPRO_NIOS_CPP_COMMAND_LINE" "-O3";
swb add_assignment "" "" "" "OUTPUT_FILE_NAME" "Release\\blink.hex";
swb add_assignment "" "" "" "OUTPUT_TYPE" "INTEL HEX";
swb add_assignment "" "" "" "PROCESSOR" "ARM922T";
swb add_assignment "" "" "" "PROGRAMMING_FILE_TYPE" "NO PROGRAMMING FILE";
swb add_assignment "" "" "" "TOOLSET" "CUSTOM BUILD";
swb add_assignment "" "" "" "USE_C_PREPROCESSOR_FOR_GNU_ASM_FILES" "ON";

# Software Build Assignments for debug
if {![project swb_exists debug]} {
	project create_swb debug;
}
project set_active_swb debug;

swb add_assignment "" "" "" "ARM_ASM_COMMAND_LINE" "-g -keep";
swb add_assignment "" "" "" "ARM_CPP_COMMAND_LINE" "-g -O0";
swb add_assignment "" "" "" "ASP_ASM_COMMAND_LINE" "-g";
swb add_assignment "" "" "" "BYTE_ORDER" "LITTLE ENDIAN";
swb add_assignment "" "" "" "DO_POST_BUILD_COMMAND_LINE" "OFF";
swb add_assignment "" "" "" "GNUPRO_ARM_ASM_COMMAND_LINE" "--gdwarf2 -L";
swb add_assignment "" "" "" "GNUPRO_ARM_CPP_COMMAND_LINE" "-g -O0";
swb add_assignment "" "" "" "GNUPRO_NIOS_ASM_COMMAND_LINE" "--gdwarf2 -L";
swb add_assignment "" "" "" "GNUPRO_NIOS_CPP_COMMAND_LINE" "-g -O0";
swb add_assignment "" "" "" "OUTPUT_FILE_NAME" "Debug\\blink.hex";
swb add_assignment "" "" "" "OUTPUT_TYPE" "INTEL HEX";
swb add_assignment "" "" "" "PROCESSOR" "ARM922T";
swb add_assignment "" "" "" "PROGRAMMING_FILE_TYPE" "NO PROGRAMMING FILE";
swb add_assignment "" "" "" "TOOLSET" "CUSTOM BUILD";
swb add_assignment "" "" "" "USE_C_PREPROCESSOR_FOR_GNU_ASM_FILES" "ON";

# Simulator Assignments for blink
if {![project sim_exists blink]} {
	project create_sim blink;
}
project set_active_sim blink;

sim start_batch;
sim add_assignment "" "" "" "ADD_DEFAULT_PINS_TO_SIMULATION_OUTPUT_WAVEFORMS" "ON";
sim add_assignment "" "" "" "CHECK_OUTPUTS" "OFF";
sim add_assignment "" "" "" "SIMULATION_COVERAGE" "ON";
sim add_assignment "" "" "" "ESTIMATE_POWER_CONSUMPTION" "OFF";
sim add_assignment "" "" "" "GLITCH_DETECTION" "OFF";
sim add_assignment "" "" "" "GLITCH_INTERVAL" "1ns";
sim add_assignment "" "" "" "POWER_ESTIMATION_START_TIME" "0 ns";
sim add_assignment "" "" "" "SETUP_HOLD_DETECTION" "OFF";
sim add_assignment "" "" "" "SIMULATION_MODE" "TIMING";
sim add_assignment "" "" "" "START_TIME" "0ns";
sim add_assignment "" "" "" "USE_COMPILER_SETTINGS" "blink";
sim end_batch;

# Compiler Assignments for blink
if {![project cmp_exists blink]} {
	project create_cmp blink;
}
project set_active_cmp blink;

cmp start_batch;
cmp add_assignment "" "" "" "ADV_NETLIST_OPT_FIT_LE_DUPLICATION" "OFF";
cmp add_assignment "" "" "" "ADV_NETLIST_OPT_FIT_LE_DUPLICATION_WITH_LUT_RESYNTH" "OFF";
cmp add_assignment "" "" "" "ADV_NETLIST_OPT_RETIME_CORE_AND_IO" "ON";
cmp add_assignment "" "" "" "ADV_NETLIST_OPT_SYNTH_GATE_RETIME" "OFF";
cmp add_assignment "" "" "" "ADV_NETLIST_OPT_SYNTH_USE_FITTER_INFO" "OFF";
cmp add_assignment "" "" "" "ADV_NETLIST_OPT_SYNTH_WYSIWYG_REMAP" "OFF";
cmp add_assignment "" "" "" "COMPILATION_LEVEL" "FULL";
cmp add_assignment "" "" "" "DPRAM_32BIT_SINGLE_PORT_MODE_INPUT_EPXA1" "MEGALAB COLUMN 1";
cmp add_assignment "" "" "" "DPRAM_32BIT_SINGLE_PORT_MODE_OTHER_SIGNALS_EPXA1" "MEGALAB COLUMN 1";
cmp add_assignment "" "" "" "DPRAM_32BIT_SINGLE_PORT_MODE_OUTPUT_EPXA1" "LOWER TO 1ESB UPPER TO 1";
cmp add_assignment "" "" "" "DPRAM_8BIT_16BIT_SINGLE_PORT_MODE_INPUT_EPXA1" "MEGALAB COLUMN 1";
cmp add_assignment "" "" "" "DPRAM_8BIT_16BIT_SINGLE_PORT_MODE_OTHER_SIGNALS_EPXA1" "MEGALAB COLUMN 1";
cmp add_assignment "" "" "" "DPRAM_8BIT_16BIT_SINGLE_PORT_MODE_OUTPUT_EPXA1" "MEGALAB COLUMN 1";
cmp add_assignment "" "" "" "DPRAM_DEEP_MODE_INPUT_EPXA4_10" "MEGALAB COLUMN 3";
cmp add_assignment "" "" "" "DPRAM_DEEP_MODE_OTHER_SIGNALS_EPXA4_10" "MEGALAB COLUMN 3";
cmp add_assignment "" "" "" "DPRAM_DEEP_MODE_OUTPUT_EPXA4_10" "MEGALAB COLUMN 3";
cmp add_assignment "" "" "" "DPRAM_DUAL_PORT_MODE_INPUT_EPXA1" "DPRAM0 TO 1 DPRAM1 TO 2";
cmp add_assignment "" "" "" "DPRAM_DUAL_PORT_MODE_INPUT_EPXA4_10" "DPRAM0 TO 3 DPRAM1 TO 4";
cmp add_assignment "" "" "" "DPRAM_DUAL_PORT_MODE_OTHER_SIGNALS_EPXA1" "DPRAM0 TO 1 DPRAM1 TO 2";
cmp add_assignment "" "" "" "DPRAM_DUAL_PORT_MODE_OTHER_SIGNALS_EPXA4_10" "DPRAM0 TO 3 DPRAM1 TO 4";
cmp add_assignment "" "" "" "DPRAM_DUAL_PORT_MODE_OUTPUT_EPXA1" "DPRAM0 TO 1 DPRAM1 TO 2";
cmp add_assignment "" "" "" "DPRAM_DUAL_PORT_MODE_OUTPUT_EPXA4_10" "DPRAM0 TO 3 DPRAM1 TO 4ESB";
cmp add_assignment "" "" "" "DPRAM_INPUT_EPXA4_10" "DEFAULT INPUT ROUTING OPTIONS";
cmp add_assignment "" "" "" "DPRAM_OTHER_SIGNALS_EPXA4_10" "DEFAULT OTHER ROUTING OPTIONS";
cmp add_assignment "" "" "" "DPRAM_OUTPUT_EPXA4_10" "DEFAULT OUTPUT ROUTING OPTIONS";
cmp add_assignment "" "" "" "DPRAM_SINGLE_PORT_MODE_INPUT_EPXA4_10" "DPRAM0 TO 3 DPRAM1 TO 4";
cmp add_assignment "" "" "" "DPRAM_SINGLE_PORT_MODE_OTHER_SIGNALS_EPXA4_10" "DPRAM0 TO 3 DPRAM1 TO 4";
cmp add_assignment "" "" "" "DPRAM_SINGLE_PORT_MODE_OUTPUT_EPXA4_10" "DPRAM0 TO 3 DPRAM1 TO 4ESB";
cmp add_assignment "" "" "" "DPRAM_WIDE_MODE_INPUT_EPXA4_10" "LOWER TO 3 UPPER TO 4";
cmp add_assignment "" "" "" "DPRAM_WIDE_MODE_OTHER_SIGNALS_EPXA4_10" "MEGALAB COLUMN 3";
cmp add_assignment "" "" "" "DPRAM_WIDE_MODE_OUTPUT_EPXA4_10" "LOWER TO 3 UPPER TO 4ESB";
cmp add_assignment "" "" "" "DRC_FANOUT_EXCEEDING" "30";
cmp add_assignment "" "" "" "DRC_TOP_FANOUT" "50";
cmp add_assignment "" "" "" "DRC_REPORT_FANOUT_EXCEEDING" "OFF";
cmp add_assignment "" "" "" "DRC_REPORT_TOP_FANOUT" "OFF";
cmp add_assignment "" "" "" "RUN_DRC_DURING_COMPILATION" "OFF";
cmp add_assignment "" "" "" "FAMILY" "Cyclone";
cmp add_assignment "" "" "" "FAST_FIT_COMPILATION" "OFF";
cmp add_assignment "" "" "" "FINAL_PLACEMENT_OPTIMIZATION" "AUTOMATICALLY";
cmp add_assignment "" "" "" "INITIAL_PLACEMENT_CONFIGURATION" "1";
cmp add_assignment "" "" "" "MERGE_HEX_FILE" "OFF";
cmp add_assignment "" "" "" "OPTIMIZE_IOC_REGISTER_PLACEMENT_FOR_TIMING" "ON";
cmp add_assignment "" "" "" "PLD_TO_STRIPE_INTERRUPTS_EPXA4_10" "MEGALAB COLUMN 2";
cmp add_assignment "" "" "" "PROCESSOR_DEBUG_EXTENSIONS_EPXA4_10" "MEGALAB COLUMN 2";
cmp add_assignment "" "" "" "FOCUS_ENTITY_NAME" "|blink";
cmp add_assignment "" "" "" "RUN_FITTER_IN_SIGNALPROBE_MODE" "OFF";
cmp add_assignment "" "" "" "SAVE_DISK_SPACE" "ON";
cmp add_assignment "" "" "" "SIGNALPROBE_ALLOW_OVERUSE" "OFF";
cmp add_assignment "" "" "" "SIGNALPROBE_AUTO_ASSIGN" "0";
cmp add_assignment "" "" "" "SIGNALPROBE_COMPILATION" "OFF";
cmp add_assignment "" "" "" "SIGNALPROBE_ROUTING" "ALL_SIGNAL_PROBE";
cmp add_assignment "" "" "" "SMART_COMPILE_IGNORES_TDC_FOR_STRATIX_PLL_CHANGES" "OFF";
cmp add_assignment "" "" "" "SPEED_DISK_USAGE_TRADEOFF" "NORMAL";
cmp add_assignment "" "" "" "STRIPE_TO_PLD_BRIDGE_EPXA4_10" "MEGALAB COLUMN 1";
cmp add_assignment "" "" "" "STRIPE_TO_PLD_INTERRUPTS_EPXA4_10" "MEGALAB COLUMN 2";
cmp add_assignment "" "" "" "OPTIMIZE_TIMING" "NORMAL_COMPILATION";
cmp add_assignment "" "" "" "LOGICLOCK_INCREMENTAL_COMPILE_ASSIGNMENT" "OFF";
cmp add_assignment "" "" "" "AUTO_INCREMENT_CONFIG_DEVICE_JTAG_USER_CODE" "ON";
cmp add_assignment "" "" "" "AUTO_RESTART_CONFIGURATION" "OFF";
cmp add_assignment "" "" "" "ENABLE_DEVICE_WIDE_OE" "OFF";
cmp add_assignment "" "" "" "ENABLE_DEVICE_WIDE_RESET" "OFF";
cmp add_assignment "" "" "" "CLOCK_DIVISOR" "1";
cmp add_assignment "" "" "" "CLOCK_FREQUENCY" "10 MHZ";
cmp add_assignment "" "" "" "CLOCK_SOURCE" "INTERNAL";
cmp add_assignment "" "" "" "COMPRESSION_MODE" "OFF";
cmp add_assignment "" "" "" "RESERVE_DATA0_AFTER_CONFIGURATION" "AS INPUT TRI-STATED";
cmp add_assignment "" "" "" "RESERVE_DATA7_THROUGH_DATA1_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "" "" "" "DISABLE_NCS_AND_OE_PULLUPS_ON_CONFIG_DEVICE" "OFF";
cmp add_assignment "" "" "" "ENABLE_LOW_VOLTAGE_MODE_ON_CONFIG_DEVICE" "ON";
cmp add_assignment "" "" "" "FLEX10K_ENABLE_LOW_VOLTAGE_MODE_ON_CONFIG_DEVICE" "ON";
cmp add_assignment "" "" "" "FLEX6K_ENABLE_LOW_VOLTAGE_MODE_ON_CONFIG_DEVICE" "OFF";
cmp add_assignment "" "" "" "ENABLE_VREFA_PIN" "OFF";
cmp add_assignment "" "" "" "ENABLE_VREFB_PIN" "OFF";
cmp add_assignment "" "" "" "APEX20K_CONFIG_DEVICE_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "" "" "" "MERCURY_CONFIG_DEVICE_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "" "" "" "FLEX10K_CONFIG_DEVICE_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "" "" "" "STRATIX_CONFIG_DEVICE_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "" "" "" "EPROM_USE_CHECKSUM_AS_USERCODE" "OFF";
cmp add_assignment "" "" "" "GENERATE_CONFIG_HEXOUT_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_CONFIG_ISC_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_CONFIG_JAM_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_CONFIG_JBC_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_CONFIG_JBC_FILE_COMPRESSED" "ON";
cmp add_assignment "" "" "" "GENERATE_CONFIG_SVF_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_HEX_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_ISC_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_JAM_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_JBC_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_JBC_FILE_COMPRESSED" "ON";
cmp add_assignment "" "" "" "GENERATE_RBF_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_SVF_FILE" "OFF";
cmp add_assignment "" "" "" "GENERATE_TTF_FILE" "OFF";
cmp add_assignment "" "" "" "HEXOUT_FILE_COUNT_DIRECTION" "UP";
cmp add_assignment "" "" "" "HEXOUT_FILE_START_ADDRESS" "0";
cmp add_assignment "" "" "" "ENABLE_INIT_DONE_OUTPUT" "OFF";
cmp add_assignment "" "" "" "ENABLE_JTAG_BST_SUPPORT" "OFF";
cmp add_assignment "" "" "" "MAX7000_ENABLE_JTAG_BST_SUPPORT" "ON";
cmp add_assignment "" "" "" "RESERVE_NCEO_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "" "" "" "RESERVE_NWS_NRS_NCS_CS_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "" "" "" "ON_CHIP_BITSTREAM_DECOMPRESSION" "OFF";
cmp add_assignment "" "" "" "FLEX10K_ENABLE_LOCK_OUTPUT" "OFF";
cmp add_assignment "" "" "" "APEX20K_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "" "" "" "APEXII_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "" "" "" "MERCURY_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "" "" "" "EXCALIBUR_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "" "" "" "FLEX10K_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "" "" "" "FLEX6K_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "" "" "" "CYCLONE_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "" "" "" "STRATIX_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "" "" "" "RESERVE_RDYNBUSY_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "" "" "" "RELEASE_CLEARS_BEFORE_TRI_STATES" "OFF";
cmp add_assignment "" "" "" "RESERVE_ALL_UNUSED_PINS" "AS OUTPUT DRIVING GROUND";
cmp add_assignment "" "" "" "RESERVE_PIN" "AS INPUT TRI-STATED";
cmp add_assignment "" "" "" "RESERVE_NCSO_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "" "" "" "RESERVE_ASDO_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "" "" "" "SECURITY_BIT" "OFF";
cmp add_assignment "" "" "" "USER_START_UP_CLOCK" "OFF";
cmp add_assignment "" "" "" "STRATIX_UPDATE_MODE" "STANDARD";
cmp add_assignment "" "" "" "APEX20K_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "" "" "" "MERCURY_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "" "" "" "FLEX10K_JTAG_USER_CODE" "7F";
cmp add_assignment "" "" "" "MAX7000_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "" "" "" "STRATIX_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "" "" "" "USE_CHECKSUM_AS_USERCODE" "OFF";
cmp add_assignment "" "" "" "MAX7000_USE_CHECKSUM_AS_USERCODE" "OFF";
cmp add_assignment "" "" "" "APEX20K_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "" "" "" "CYCLONE_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "" "" "" "MERCURY_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "" "" "" "EXCALIBUR_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "" "" "" "FLEX10K_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "" "" "" "FLEX6K_CONFIGURATION_DEVICE" "EPC1";
cmp add_assignment "" "" "" "STRATIX_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "" "" "" "USE_CONFIGURATION_DEVICE" "ON";
cmp add_assignment "" "" "" "AUTO_INSERT_SLD_HUB_ENTITY" "ENABLE";
cmp add_assignment "" "" "" "HUB_ENTITY_NAME" "sld_hub";
cmp add_assignment "" "" "" "HUB_INSTANCE_NAME" "sld_hub_inst";
cmp add_assignment "blink" "" "" "AUTO_INCREMENT_CONFIG_DEVICE_JTAG_USER_CODE" "ON";
cmp add_assignment "blink" "" "" "AUTO_RESTART_CONFIGURATION" "OFF";
cmp add_assignment "blink" "" "" "BASE_PIN_OUT_FILE_ON_SAMEFRAME_DEVICE" "OFF";
cmp add_assignment "blink" "" "" "ENABLE_DEVICE_WIDE_OE" "OFF";
cmp add_assignment "blink" "" "" "ENABLE_DEVICE_WIDE_RESET" "OFF";
cmp add_assignment "blink" "" "" "CLOCK_DIVISOR" "1";
cmp add_assignment "blink" "" "" "CLOCK_FREQUENCY" "10 MHZ";
cmp add_assignment "blink" "" "" "CLOCK_SOURCE" "INTERNAL";
cmp add_assignment "blink" "" "" "COMPRESSION_MODE" "OFF";
cmp add_assignment "blink" "" "" "RESERVE_DATA0_AFTER_CONFIGURATION" "AS INPUT TRI-STATED";
cmp add_assignment "blink" "" "" "RESERVE_DATA7_THROUGH_DATA1_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "blink" "" "" "DEVICE" "EP1C6Q240C8";
cmp add_assignment "blink" "" "" "STRATIX_DEVICE_IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "" "DISABLE_NCS_AND_OE_PULLUPS_ON_CONFIG_DEVICE" "OFF";
cmp add_assignment "blink" "" "" "ENABLE_LOW_VOLTAGE_MODE_ON_CONFIG_DEVICE" "ON";
cmp add_assignment "blink" "" "" "FLEX10K_ENABLE_LOW_VOLTAGE_MODE_ON_CONFIG_DEVICE" "ON";
cmp add_assignment "blink" "" "" "FLEX6K_ENABLE_LOW_VOLTAGE_MODE_ON_CONFIG_DEVICE" "OFF";
cmp add_assignment "blink" "" "" "ENABLE_VREFA_PIN" "OFF";
cmp add_assignment "blink" "" "" "ENABLE_VREFB_PIN" "OFF";
cmp add_assignment "blink" "" "" "APEX20K_CONFIG_DEVICE_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "blink" "" "" "MERCURY_CONFIG_DEVICE_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "blink" "" "" "FLEX10K_CONFIG_DEVICE_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "blink" "" "" "STRATIX_CONFIG_DEVICE_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "blink" "" "" "EPROM_USE_CHECKSUM_AS_USERCODE" "OFF";
cmp add_assignment "blink" "" "" "DEVICE_FILTER_PACKAGE" "ANY";
cmp add_assignment "blink" "" "" "DEVICE_FILTER_PIN_COUNT" "ANY";
cmp add_assignment "blink" "" "" "DEVICE_FILTER_SPEED_GRADE" "ANY";
cmp add_assignment "blink" "" "" "GENERATE_CONFIG_HEXOUT_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_CONFIG_ISC_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_CONFIG_JAM_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_CONFIG_JBC_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_CONFIG_JBC_FILE_COMPRESSED" "ON";
cmp add_assignment "blink" "" "" "GENERATE_CONFIG_SVF_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_HEX_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_ISC_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_JAM_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_JBC_FILE" "ON";
cmp add_assignment "blink" "" "" "GENERATE_JBC_FILE_COMPRESSED" "ON";
cmp add_assignment "blink" "" "" "GENERATE_RBF_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_SVF_FILE" "OFF";
cmp add_assignment "blink" "" "" "GENERATE_TTF_FILE" "OFF";
cmp add_assignment "blink" "" "" "HEXOUT_FILE_COUNT_DIRECTION" "UP";
cmp add_assignment "blink" "" "" "HEXOUT_FILE_START_ADDRESS" "0";
cmp add_assignment "blink" "" "" "ENABLE_INIT_DONE_OUTPUT" "OFF";
cmp add_assignment "blink" "" "clk" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_gnd\[0\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_gnd\[1\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_gnd\[2\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_gnd\[3\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_gnd\[4\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_gnd\[5\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_vccint\[0\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_vccint\[1\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_vccint\[2\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_vccint\[3\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_vccint\[4\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "dummy_vccint\[5\]" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "wd" "IO_STANDARD" "LVTTL";
cmp add_assignment "blink" "" "" "ENABLE_JTAG_BST_SUPPORT" "OFF";
cmp add_assignment "blink" "" "" "MAX7000_ENABLE_JTAG_BST_SUPPORT" "ON";
cmp add_assignment "blink" "" "clk" "LOCATION" "Pin_152";
cmp add_assignment "blink" "" "dummy_gnd\[0\]" "LOCATION" "Pin_80";
cmp add_assignment "blink" "" "dummy_gnd\[1\]" "LOCATION" "Pin_96";
cmp add_assignment "blink" "" "dummy_gnd\[2\]" "LOCATION" "Pin_102";
cmp add_assignment "blink" "" "dummy_gnd\[3\]" "LOCATION" "Pin_199";
cmp add_assignment "blink" "" "dummy_gnd\[4\]" "LOCATION" "Pin_205";
cmp add_assignment "blink" "" "dummy_gnd\[5\]" "LOCATION" "Pin_221";
cmp add_assignment "blink" "" "dummy_vccint\[0\]" "LOCATION" "Pin_81";
cmp add_assignment "blink" "" "dummy_vccint\[1\]" "LOCATION" "Pin_97";
cmp add_assignment "blink" "" "dummy_vccint\[2\]" "LOCATION" "Pin_103";
cmp add_assignment "blink" "" "dummy_vccint\[3\]" "LOCATION" "Pin_198";
cmp add_assignment "blink" "" "dummy_vccint\[4\]" "LOCATION" "Pin_204";
cmp add_assignment "blink" "" "dummy_vccint\[5\]" "LOCATION" "Pin_220";
cmp add_assignment "blink" "" "wd" "LOCATION" "Pin_166";
cmp add_assignment "blink" "" "" "RESERVE_NCEO_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "blink" "" "" "RESERVE_NWS_NRS_NCS_CS_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "blink" "" "" "ON_CHIP_BITSTREAM_DECOMPRESSION" "OFF";
cmp add_assignment "blink" "" "" "FLEX10K_ENABLE_LOCK_OUTPUT" "OFF";
cmp add_assignment "blink" "" "" "APEX20K_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "blink" "" "" "APEXII_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "blink" "" "" "MERCURY_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "blink" "" "" "EXCALIBUR_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "blink" "" "" "FLEX10K_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "blink" "" "" "FLEX6K_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "blink" "" "" "CYCLONE_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "blink" "" "" "STRATIX_CONFIGURATION_SCHEME" "PASSIVE SERIAL";
cmp add_assignment "blink" "" "" "RESERVE_RDYNBUSY_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "blink" "" "" "RELEASE_CLEARS_BEFORE_TRI_STATES" "OFF";
cmp add_assignment "blink" "" "" "RESERVE_ALL_UNUSED_PINS" "AS INPUT TRI-STATED";
cmp add_assignment "blink" "" "" "RESERVE_NCSO_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "blink" "" "" "RESERVE_ASDO_AFTER_CONFIGURATION" "OFF";
cmp add_assignment "blink" "" "" "SECURITY_BIT" "OFF";
cmp add_assignment "blink" "" "clk" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_gnd\[0\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_gnd\[1\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_gnd\[2\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_gnd\[3\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_gnd\[4\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_gnd\[5\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_vccint\[0\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_vccint\[1\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_vccint\[2\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_vccint\[3\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_vccint\[4\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "dummy_vccint\[5\]" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "wd" "SIGNALPROBE_ENABLE" "OFF";
cmp add_assignment "blink" "" "" "USER_START_UP_CLOCK" "OFF";
cmp add_assignment "blink" "" "" "STRATIX_UPDATE_MODE" "STANDARD";
cmp add_assignment "blink" "" "" "APEX20K_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "blink" "" "" "MERCURY_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "blink" "" "" "FLEX10K_JTAG_USER_CODE" "7F";
cmp add_assignment "blink" "" "" "MAX7000_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "blink" "" "" "STRATIX_JTAG_USER_CODE" "FFFFFFFF";
cmp add_assignment "blink" "" "" "USE_CHECKSUM_AS_USERCODE" "OFF";
cmp add_assignment "blink" "" "" "MAX7000_USE_CHECKSUM_AS_USERCODE" "OFF";
cmp add_assignment "blink" "" "" "APEX20K_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "blink" "" "" "CYCLONE_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "blink" "" "" "MERCURY_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "blink" "" "" "EXCALIBUR_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "blink" "" "" "FLEX10K_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "blink" "" "" "FLEX6K_CONFIGURATION_DEVICE" "EPC1";
cmp add_assignment "blink" "" "" "STRATIX_CONFIGURATION_DEVICE" "EPC2";
cmp add_assignment "blink" "" "" "USE_CONFIGURATION_DEVICE" "ON";
cmp end_batch;

# Project Assignments
project start_batch "";
project add_assignment "" "" "" "" "VHDL_FILE" "blink.vhd";
project add_assignment "" "" "" "" "CDF_FILE" "Chain1.cdf";
project add_assignment "" "" "" "" "COMPILER_SETTINGS" "blink";
project add_assignment "" "" "" "" "SIMULATOR_SETTINGS" "blink";
project add_assignment "" "" "" "" "SOFTWARE_SETTINGS" "Debug";
project add_assignment "" "" "" "" "SOFTWARE_SETTINGS" "Release";
project end_batch "";

# Project Assignments and/or Default Parameter
project start_batch "";
project add_assignment "" "" "" "" "ACLK_CAT" "OFF";
project add_assignment "" "" "" "" "ACLK_RULE_IMSZER_ADOMAIN" "OFF";
project add_assignment "" "" "" "" "ACLK_RULE_NO_SZER_ACLK_DOMAIN" "OFF";
project add_assignment "" "" "" "" "ACLK_RULE_SZER_BTW_ACLK_DOMAIN" "OFF";
project add_assignment "" "" "" "" "CLK_CAT" "OFF";
project add_assignment "" "" "" "" "CLK_RULE_ALL" "OFF";
project add_assignment "" "" "" "" "CLK_RULE_CLKNET_CLKSPINES" "OFF";
project add_assignment "" "" "" "" "CLK_RULE_COMB_CLOCK" "OFF";
project add_assignment "" "" "" "" "CLK_RULE_GATING_SCHEME" "OFF";
project add_assignment "" "" "" "" "CLK_RULE_INPINS_CLKNET" "OFF";
project add_assignment "" "" "" "" "CLK_RULE_INV_CLOCK" "OFF";
project add_assignment "" "" "" "" "CLK_RULE_MIX_EDGES" "OFF";
project add_assignment "" "" "" "" "HCPY_ALOAD_SIGNALS" "OFF";
project add_assignment "" "" "" "" "HCPY_CAT" "OFF";
project add_assignment "" "" "" "" "HCPY_EXCEED_RAM_USAGE" "OFF";
project add_assignment "" "" "" "" "HCPY_EXCEED_USER_IO_USAGE" "OFF";
project add_assignment "" "" "" "" "HCPY_ILLEGAL_HC_DEV_PKG" "OFF";
project add_assignment "" "" "" "" "HCPY_VREF_PINS" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_CAT" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_COMBLOOP" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_DELAY_CHAIN" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_DLATCH" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_ILLEGAL_PULSE_GEN" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_LATCH_UNIDENTIFIED" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_MULTI_VIBRATOR" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_REG_LOOP" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_RIPPLE_CLK" "OFF";
project add_assignment "" "" "" "" "NONSYNCHSTRUCT_RULE_SRLATCH" "OFF";
project add_assignment "" "" "" "" "RESET_CAT" "OFF";
project add_assignment "" "" "" "" "RESET_RULE_ALL" "OFF";
project add_assignment "" "" "" "" "RESET_RULE_COMB_ASYNCH_RESET" "OFF";
project add_assignment "" "" "" "" "RESET_RULE_IMSYNCH_ASYNCH_DOMAIN" "OFF";
project add_assignment "" "" "" "" "RESET_RULE_IMSYNCH_EXRESET" "OFF";
project add_assignment "" "" "" "" "RESET_RULE_INPINS_RESETNET" "OFF";
project add_assignment "" "" "" "" "RESET_RULE_REG_ASNYCH" "OFF";
project add_assignment "" "" "" "" "RESET_RULE_UNSYNCH_ASYNCH_DOMAIN" "OFF";
project add_assignment "" "" "" "" "RESET_RULE_UNSYNCH_EXRESET" "OFF";
project add_assignment "" "" "" "" "SIGNALRACE_CAT" "OFF";
project add_assignment "" "" "" "" "SIGNALRACE_RULE_ASYNCHPIN_SYNCH_CLKPIN" "OFF";
project add_assignment "" "" "" "" "TIMING_CAT" "OFF";
project add_assignment "" "" "" "" "TIMING_RULE_COIN_CLKEDGE" "OFF";
project add_assignment "" "" "" "" "TIMING_RULE_HIGH_FANOUTS" "OFF";
project add_assignment "" "" "" "" "TIMING_RULE_SHIFT_REG" "OFF";
project add_assignment "" "" "" "" "LIMIT_AHDL_INTEGERS_TO_32_BITS" "OFF";
project add_assignment "" "" "" "" "USE_LPM_FOR_AHDL_OPERATORS" "ON";
project add_assignment "" "" "" "" "ALLOW_POWER_UP_DONT_CARE" "ON";
project add_assignment "" "" "" "" "AUTO_CARRY_CHAINS" "ON";
project add_assignment "" "" "" "" "AUTO_CASCADE_CHAINS" "ON";
project add_assignment "" "" "" "" "AUTO_DELAY_CHAINS" "ON";
project add_assignment "" "" "" "" "AUTO_DSP_RECOGNITION" "ON";
project add_assignment "" "" "" "" "AUTO_GLOBAL_CLOCK" "ON";
project add_assignment "" "" "" "" "AUTO_GLOBAL_MEMORY_CONTROLS" "OFF";
project add_assignment "" "" "" "" "AUTO_GLOBAL_OE" "ON";
project add_assignment "" "" "" "" "AUTO_GLOBAL_REGISTER_CONTROLS" "ON";
project add_assignment "" "" "" "" "AUTO_FAST_INPUT_REGISTERS" "OFF";
project add_assignment "" "" "" "" "AUTO_LCELL_INSERTION" "ON";
project add_assignment "" "" "" "" "AUTO_MERGE_PLLS" "ON";
project add_assignment "" "" "" "" "AUTO_OPEN_DRAIN_PINS" "ON";
project add_assignment "" "" "" "" "AUTO_FAST_OUTPUT_ENABLE_REGISTERS" "OFF";
project add_assignment "" "" "" "" "AUTO_FAST_OUTPUT_REGISTERS" "OFF";
project add_assignment "" "" "" "" "AUTO_PARALLEL_EXPANDERS" "ON";
project add_assignment "" "" "" "" "AUTO_RAM_RECOGNITION" "ON";
project add_assignment "" "" "" "" "AUTO_IMPLEMENT_IN_ROM" "OFF";
project add_assignment "" "" "" "" "AUTO_SHIFT_REGISTER_RECOGNITION" "ON";
project add_assignment "" "" "" "" "AUTO_TURBO_BIT" "ON";
project add_assignment "" "" "" "" "CARRY_CHAIN_LENGTH" "48";
project add_assignment "" "" "" "" "MERCURY_CARRY_CHAIN_LENGTH" "48";
project add_assignment "" "" "" "" "FLEX10K_CARRY_CHAIN_LENGTH" "32";
project add_assignment "" "" "" "" "FLEX6K_CARRY_CHAIN_LENGTH" "32";
project add_assignment "" "" "" "" "STRATIX_CARRY_CHAIN_LENGTH" "70";
project add_assignment "" "" "" "" "CARRY_OUT_PINS_LCELL_INSERT" "ON";
project add_assignment "" "" "" "" "CASCADE_CHAIN_LENGTH" "2";
project add_assignment "" "" "" "" "DSP_BLOCK_BALANCING" "AUTO";
project add_assignment "" "" "" "" "REMOVE_DUPLICATE_LOGIC" "ON";
project add_assignment "" "" "" "" "REMOVE_DUPLICATE_REGISTERS" "ON";
project add_assignment "" "" "" "" "ENABLE_BUS_HOLD_CIRCUITRY" "OFF";
project add_assignment "" "" "" "" "IGNORE_CARRY_BUFFERS" "OFF";
project add_assignment "" "" "" "" "IGNORE_CASCADE_BUFFERS" "OFF";
project add_assignment "" "" "" "" "IGNORE_GLOBAL_BUFFERS" "OFF";
project add_assignment "" "" "" "" "IGNORE_LCELL_BUFFERS" "OFF";
project add_assignment "" "" "" "" "IGNORE_ROW_GLOBAL_BUFFERS" "OFF";
project add_assignment "" "" "" "" "IGNORE_SOFT_BUFFERS" "ON";
project add_assignment "" "" "" "" "MAX7000_IGNORE_SOFT_BUFFERS" "OFF";
project add_assignment "" "" "" "" "NORMAL_LCELL_INSERT" "ON";
project add_assignment "" "" "" "" "NOT_GATE_PUSH_BACK" "ON";
project add_assignment "" "" "" "" "APEX20K_OPTIMIZATION_TECHNIQUE" "SPEED";
project add_assignment "" "" "" "" "CYCLONE_OPTIMIZATION_TECHNIQUE" "AREA";
project add_assignment "" "" "" "" "MERCURY_OPTIMIZATION_TECHNIQUE" "AREA";
project add_assignment "" "" "" "" "FLEX10K_OPTIMIZATION_TECHNIQUE" "AREA";
project add_assignment "" "" "" "" "FLEX6K_OPTIMIZATION_TECHNIQUE" "AREA";
project add_assignment "" "" "" "" "MAX7000_OPTIMIZATION_TECHNIQUE" "SPEED";
project add_assignment "" "" "" "" "STRATIX_OPTIMIZATION_TECHNIQUE" "SPEED";
project add_assignment "" "" "" "" "PCI_IO" "OFF";
project add_assignment "" "" "" "" "PARALLEL_EXPANDER_CHAIN_LENGTH" "16";
project add_assignment "" "" "" "" "MAX7000_PARALLEL_EXPANDER_CHAIN_LENGTH" "4";
project add_assignment "" "" "" "" "AUTO_PACKED_REGISTERS" "OFF";
project add_assignment "" "" "" "" "AUTO_PACKED_REG_CYCLONE" "NORMAL";
project add_assignment "" "" "" "" "AUTO_PACKED_REGISTERS_STRATIX" "NORMAL";
project add_assignment "" "" "" "" "REMOVE_REDUNDANT_LOGIC_CELLS" "OFF";
project add_assignment "" "" "" "" "SLOW_SLEW_RATE" "OFF";
project add_assignment "" "" "" "" "STATE_MACHINE_PROCESSING" "AUTO";
project add_assignment "" "" "" "" "APEX20K_TECHNOLOGY_MAPPER" "LUT";
project add_assignment "" "" "" "" "MERCURY_TECHNOLOGY_MAPPER" "LUT";
project add_assignment "" "" "" "" "FLEX10K_TECHNOLOGY_MAPPER" "LUT";
project add_assignment "" "" "" "" "FLEX6K_TECHNOLOGY_MAPPER" "LUT";
project add_assignment "" "" "" "" "MAX7000_TECHNOLOGY_MAPPER" "PRODUCT TERM";
project add_assignment "" "" "" "" "STRATIX_TECHNOLOGY_MAPPER" "LUT";
project add_assignment "" "" "" "" "TURBO_BIT" "ON";
project add_assignment "" "" "" "" "WEAK_PULL_UP_RESISTOR" "OFF";
project add_assignment "" "" "" "" "ALLOW_XOR_GATE_USAGE" "ON";
project add_assignment "" "" "" "" "HARDCOPY_EXTERNAL_CLOCK_JITTER" "0.0 ns";
project add_assignment "" "" "" "" "HCPY_GEN_FILES_DURING_COMPILATION" "OFF";
project add_assignment "" "" "" "" "HARDCOPY_MINIMUM_REQUIRED_TCO" "0.0 ns";
project add_assignment "" "" "" "" "HARDCOPY_MINIMUM_REQUIRED_TPD" "0.0 ns";
project add_assignment "" "" "" "" "CUT_OFF_CLEAR_AND_PRESET_PATHS" "ON";
project add_assignment "" "" "" "" "CUT_OFF_IO_PIN_FEEDBACK" "ON";
project add_assignment "" "" "" "" "CUT_OFF_PATHS_BETWEEN_CLOCK_DOMAINS" "ON";
project add_assignment "" "" "" "" "CUT_OFF_READ_DURING_WRITE_PATHS" "ON";
project add_assignment "" "" "" "" "INCLUDE_EXTERNAL_PIN_DELAYS_IN_FMAX_CALCULATIONS" "OFF";
project add_assignment "" "" "" "" "DEFAULT_HOLD_MULTICYCLE" "SAME AS MULTICYCLE";
project add_assignment "" "" "" "" "IGNORE_CLOCK_SETTINGS" "OFF";
project add_assignment "" "" "" "" "MAX_SCC_SIZE" "50";
project add_assignment "" "" "" "" "NUMBER_OF_DESTINATION_TO_REPORT" "10";
project add_assignment "" "" "" "" "NUMBER_OF_PATHS_TO_REPORT" "200";
project add_assignment "" "" "" "" "RUN_ALL_TIMING_ANALYSES" "OFF";
project add_assignment "" "" "" "" "NUMBER_OF_SOURCES_PER_DESTINATION_TO_REPORT" "10";
project add_assignment "" "" "" "" "VERILOG_INPUT_VERSION" "VERILOG_2001";
project add_assignment "" "blink" "" "" "LAST_QUARTUS_VERSION" "2.2";
project add_assignment "" "blink" "" "" "ORIGINAL_QUARTUS_VERSION" "2.2";
project add_assignment "" "blink" "" "" "SHOW_REGISTRATION_MESSAGE" "ON";
project add_assignment "" "blink" "" "" "EDA_BOARD_DESIGN_TOOL" "<NONE>";
project add_assignment "" "blink" "" "" "EDA_DESIGN_ENTRY_SYNTHESIS_TOOL" "<NONE>";
project add_assignment "" "blink" "" "" "EDA_FORMAL_VERIFICATION_TOOL" "<NONE>";
project add_assignment "" "blink" "" "" "EDA_RESYNTHESIS_TOOL" "<NONE>";
project add_assignment "" "blink" "" "" "EDA_SIMULATION_TOOL" "<NONE>";
project add_assignment "" "blink" "" "" "EDA_TIMING_ANALYSIS_TOOL" "<NONE>";
project add_assignment "" "eda_design_synthesis" "" "" "EDA_INPUT_DATA_FORMAT" "EDIF";
project add_assignment "" "eda_design_synthesis" "" "" "EDA_INPUT_GND_NAME" "GND";
project add_assignment "" "eda_design_synthesis" "" "" "EDA_INPUT_VCC_NAME" "VCC";
project add_assignment "" "eda_design_synthesis" "" "" "EDA_RUN_TOOL_AUTOMATICALLY" "OFF";
project add_assignment "" "eda_design_synthesis" "" "" "EDA_OUTPUT_DATA_FORMAT" "NONE";
project add_assignment "" "eda_design_synthesis" "" "" "EDA_SHOW_LMF_MAPPING_MESSAGES" "OFF";
project add_assignment "" "eda_design_synthesis" "" "" "RESYNTHESIS_EXTRA_DEBUGGING_INFORMATION" "OFF";
project add_assignment "" "eda_design_synthesis" "" "" "RESYNTHESIS_OPTIMIZATION_EFFORT" "NORMAL";
project add_assignment "" "eda_design_synthesis" "" "" "RESYNTHESIS_PHYSICAL_SYNTHESIS" "NORMAL";
project add_assignment "" "eda_design_synthesis" "" "" "RESYNTHESIS_RETIMING" "FULL";
project add_assignment "" "eda_design_synthesis" "" "" "USE_GENERATED_PHYSICAL_CONSTRAINTS" "ON";
project add_assignment "" "eda_simulation" "" "" "EDA_EXCALIBUR_ATOMS_AS_SINGLE_STRIPE" "OFF";
project add_assignment "" "eda_simulation" "" "" "EDA_FLATTEN_BUSES" "OFF";
project add_assignment "" "eda_simulation" "" "" "EDA_GENERATE_SDF_OUTPUT_FILE" "ON";
project add_assignment "" "eda_simulation" "" "" "EDA_RUN_TOOL_AUTOMATICALLY" "OFF";
project add_assignment "" "eda_simulation" "" "" "EDA_MAINTAIN_DESIGN_HIERARCHY" "OFF";
project add_assignment "" "eda_simulation" "" "" "EDA_MAP_ILLEGAL_CHARACTERS" "OFF";
project add_assignment "" "eda_simulation" "" "" "EDA_OUTPUT_DATA_FORMAT" "NONE";
project add_assignment "" "eda_simulation" "" "" "EDA_TRUNCATE_LONG_HIERARCHY_PATHS" "OFF";
project add_assignment "" "eda_simulation" "" "" "EDA_INCLUDE_VHDL_CONFIGURATION_DECLARATION" "OFF";
project add_assignment "" "eda_simulation" "" "" "EDA_WRITE_DEVICE_CONTROL_PORTS" "OFF";
project add_assignment "" "eda_simulation" "" "" "RESYNTHESIS_EXTRA_DEBUGGING_INFORMATION" "OFF";
project add_assignment "" "eda_simulation" "" "" "RESYNTHESIS_OPTIMIZATION_EFFORT" "NORMAL";
project add_assignment "" "eda_simulation" "" "" "RESYNTHESIS_PHYSICAL_SYNTHESIS" "NORMAL";
project add_assignment "" "eda_simulation" "" "" "RESYNTHESIS_RETIMING" "FULL";
project add_assignment "" "eda_simulation" "" "" "USE_GENERATED_PHYSICAL_CONSTRAINTS" "ON";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_EXCALIBUR_ATOMS_AS_SINGLE_STRIPE" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_FLATTEN_BUSES" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_GENERATE_SDF_OUTPUT_FILE" "ON";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_RUN_TOOL_AUTOMATICALLY" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_MAINTAIN_DESIGN_HIERARCHY" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_MAP_ILLEGAL_CHARACTERS" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_OUTPUT_DATA_FORMAT" "NONE";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_TRUNCATE_LONG_HIERARCHY_PATHS" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_INCLUDE_VHDL_CONFIGURATION_DECLARATION" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "EDA_WRITE_DEVICE_CONTROL_PORTS" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "RESYNTHESIS_EXTRA_DEBUGGING_INFORMATION" "OFF";
project add_assignment "" "eda_timing_analysis" "" "" "RESYNTHESIS_OPTIMIZATION_EFFORT" "NORMAL";
project add_assignment "" "eda_timing_analysis" "" "" "RESYNTHESIS_PHYSICAL_SYNTHESIS" "NORMAL";
project add_assignment "" "eda_timing_analysis" "" "" "RESYNTHESIS_RETIMING" "FULL";
project add_assignment "" "eda_timing_analysis" "" "" "USE_GENERATED_PHYSICAL_CONSTRAINTS" "ON";
project add_assignment "" "eda_board_design" "" "" "EDA_EXCALIBUR_ATOMS_AS_SINGLE_STRIPE" "OFF";
project add_assignment "" "eda_board_design" "" "" "EDA_FLATTEN_BUSES" "OFF";
project add_assignment "" "eda_board_design" "" "" "EDA_GENERATE_SDF_OUTPUT_FILE" "ON";
project add_assignment "" "eda_board_design" "" "" "EDA_RUN_TOOL_AUTOMATICALLY" "OFF";
project add_assignment "" "eda_board_design" "" "" "EDA_MAINTAIN_DESIGN_HIERARCHY" "OFF";
project add_assignment "" "eda_board_design" "" "" "EDA_MAP_ILLEGAL_CHARACTERS" "OFF";
project add_assignment "" "eda_board_design" "" "" "EDA_OUTPUT_DATA_FORMAT" "NONE";
project add_assignment "" "eda_board_design" "" "" "EDA_TRUNCATE_LONG_HIERARCHY_PATHS" "OFF";
project add_assignment "" "eda_board_design" "" "" "EDA_INCLUDE_VHDL_CONFIGURATION_DECLARATION" "OFF";
project add_assignment "" "eda_board_design" "" "" "EDA_WRITE_DEVICE_CONTROL_PORTS" "OFF";
project add_assignment "" "eda_board_design" "" "" "RESYNTHESIS_EXTRA_DEBUGGING_INFORMATION" "OFF";
project add_assignment "" "eda_board_design" "" "" "RESYNTHESIS_OPTIMIZATION_EFFORT" "NORMAL";
project add_assignment "" "eda_board_design" "" "" "RESYNTHESIS_PHYSICAL_SYNTHESIS" "NORMAL";
project add_assignment "" "eda_board_design" "" "" "RESYNTHESIS_RETIMING" "FULL";
project add_assignment "" "eda_board_design" "" "" "USE_GENERATED_PHYSICAL_CONSTRAINTS" "ON";
project add_assignment "" "eda_formal_verification" "" "" "EDA_EXCALIBUR_ATOMS_AS_SINGLE_STRIPE" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "EDA_FLATTEN_BUSES" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "EDA_GENERATE_SDF_OUTPUT_FILE" "ON";
project add_assignment "" "eda_formal_verification" "" "" "EDA_RUN_TOOL_AUTOMATICALLY" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "EDA_MAINTAIN_DESIGN_HIERARCHY" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "EDA_MAP_ILLEGAL_CHARACTERS" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "EDA_OUTPUT_DATA_FORMAT" "NONE";
project add_assignment "" "eda_formal_verification" "" "" "EDA_TRUNCATE_LONG_HIERARCHY_PATHS" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "EDA_INCLUDE_VHDL_CONFIGURATION_DECLARATION" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "EDA_WRITE_DEVICE_CONTROL_PORTS" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "RESYNTHESIS_EXTRA_DEBUGGING_INFORMATION" "OFF";
project add_assignment "" "eda_formal_verification" "" "" "RESYNTHESIS_OPTIMIZATION_EFFORT" "NORMAL";
project add_assignment "" "eda_formal_verification" "" "" "RESYNTHESIS_PHYSICAL_SYNTHESIS" "NORMAL";
project add_assignment "" "eda_formal_verification" "" "" "RESYNTHESIS_RETIMING" "FULL";
project add_assignment "" "eda_formal_verification" "" "" "USE_GENERATED_PHYSICAL_CONSTRAINTS" "ON";
project add_assignment "" "eda_palace" "" "" "EDA_EXCALIBUR_ATOMS_AS_SINGLE_STRIPE" "OFF";
project add_assignment "" "eda_palace" "" "" "EDA_FLATTEN_BUSES" "OFF";
project add_assignment "" "eda_palace" "" "" "EDA_GENERATE_SDF_OUTPUT_FILE" "ON";
project add_assignment "" "eda_palace" "" "" "EDA_RUN_TOOL_AUTOMATICALLY" "OFF";
project add_assignment "" "eda_palace" "" "" "EDA_MAINTAIN_DESIGN_HIERARCHY" "OFF";
project add_assignment "" "eda_palace" "" "" "EDA_MAP_ILLEGAL_CHARACTERS" "OFF";
project add_assignment "" "eda_palace" "" "" "EDA_OUTPUT_DATA_FORMAT" "NONE";
project add_assignment "" "eda_palace" "" "" "EDA_TRUNCATE_LONG_HIERARCHY_PATHS" "OFF";
project add_assignment "" "eda_palace" "" "" "EDA_INCLUDE_VHDL_CONFIGURATION_DECLARATION" "OFF";
project add_assignment "" "eda_palace" "" "" "EDA_WRITE_DEVICE_CONTROL_PORTS" "OFF";
project add_assignment "" "eda_palace" "" "" "RESYNTHESIS_EXTRA_DEBUGGING_INFORMATION" "OFF";
project add_assignment "" "eda_palace" "" "" "RESYNTHESIS_OPTIMIZATION_EFFORT" "NORMAL";
project add_assignment "" "eda_palace" "" "" "RESYNTHESIS_PHYSICAL_SYNTHESIS" "NORMAL";
project add_assignment "" "eda_palace" "" "" "RESYNTHESIS_RETIMING" "FULL";
project add_assignment "" "eda_palace" "" "" "USE_GENERATED_PHYSICAL_CONSTRAINTS" "ON";
project end_batch "";

